Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSuperquadric Class Reference

`#include <vtkSuperquadric.h>`

Inheritance diagram for vtkSuperquadric:

[legend]
Collaboration diagram for vtkSuperquadric:

[legend]
List of all members.

## Detailed Description

implicit function for a Superquadric

Date:
  2003/01/06 20:36:14

Revision:
  1.21

vtkSuperquadric computes the implicit function and function gradient for a superquadric. vtkSuperquadric is a concrete implementation of vtkImplicitFunction. The superquadric is centered at Center and axes of rotation is along the y-axis. (Use the superclass' vtkImplicitFunction transformation matrix if necessary to reposition.) Roundness parameters (PhiRoundness and ThetaRoundness) control the shape of the superquadric. The Toroidal boolean controls whether a toroidal superquadric is produced. If so, the Thickness parameter controls the thickness of the toroid: 0 is the thinnest allowable toroid, and 1 has a minimum sized hole. The Scale parameters allow the superquadric to be scaled in x, y, and z (normal vectors are correctly generated in any case). The Size parameter controls size of the superquadric.

This code is based on "Rigid physically based superquadrics", A. H. Barr, in "Graphics Gems III", David Kirk, ed., Academic Press, 1992.

Warning:
  The Size and Thickness parameters control coefficients of superquadric generation, and may do not exactly describe the size of the superquadric.

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (83%)
  - Schroeder, Will (10%)

CVS logs (CVSweb):
  - .`h` (`/Filtering/vtkSuperquadric.h)`
  - .`cxx` (`/Filtering/vtkSuperquadric.cxx)`

Definition at line 63 of file vtkSuperquadric.h.

## Public Types
typedef vtkImplicitFunction | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
float | EvaluateFunction (float x[3])
float | EvaluateFunction (float x, float y, float z)
void | EvaluateGradient (float x[3], float g[3])
virtual void | SetCenter (float, float, float)
virtual void | SetCenter (float[3])
virtual float * | GetCenter ()
virtual void | GetCenter (float data[3])
virtual void | SetScale (float, float, float)
virtual void | SetScale (float[3])
virtual float * | GetScale ()
virtual void | GetScale (float data[3])
virtual float | GetThickness ()
virtual void | SetThickness (float)
virtual float | GetPhiRoundness ()
void | SetPhiRoundness (float e)
virtual float | GetThetaRoundness ()
void | SetThetaRoundness (float e)
virtual void | SetSize (float)
virtual float | GetSize ()
virtual void | ToroidalOn ()
virtual void | ToroidalOff ()
virtual int | GetToroidal ()
virtual void | SetToroidal (int)
## Static Public Methods
vtkSuperquadric * | New ()
int | IsTypeOf (const char *type)
vtkSuperquadric * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkSuperquadric ()
| ~vtkSuperquadric ()
## Protected Attributes
int | Toroidal
float | Thickness
float | Size
float | PhiRoundness
float | ThetaRoundness
float | Center [3]
float | Scale [3]

## Member Typedef Documentation

typedef vtkImplicitFunction vtkSuperquadric::Superclass

| Reimplemented from vtkImplicitFunction. Definition at line 71 of file vtkSuperquadric.h.

## Constructor & Destructor Documentation

vtkSuperquadric::vtkSuperquadric | ( |  | ) | `[protected]`

vtkSuperquadric::~vtkSuperquadric | ( |  | ) | `[inline, protected]`

| Definition at line 129 of file vtkSuperquadric.h.

## Member Function Documentation

vtkSuperquadric* vtkSuperquadric::New | ( |  | ) | `[static]`

| Construct with superquadric radius of 0.5, toroidal off, center at 0.0, scale (1,1,1), size 0.5, phi roundness 1.0, and theta roundness 0.0. Reimplemented from vtkObject.

virtual const char* vtkSuperquadric::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImplicitFunction.

int vtkSuperquadric::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

virtual int vtkSuperquadric::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImplicitFunction.

vtkSuperquadric* vtkSuperquadric::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImplicitFunction.

void vtkSuperquadric::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImplicitFunction.

float vtkSuperquadric::EvaluateFunction | ( | float | x[3] | ) | `[virtual]`

| Evaluate function at position x-y-z and return value. You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class. Implements vtkImplicitFunction.

float vtkSuperquadric::EvaluateFunction | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Evaluate function at position x-y-z and return value. You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class. Reimplemented from vtkImplicitFunction. Definition at line 76 of file vtkSuperquadric.h. References vtkImplicitFunction::EvaluateFunction().

void vtkSuperquadric::EvaluateGradient | ( | float | x[3],
|  | float | g[3]
| ) | `[virtual]`

| Evaluate function gradient at position x-y-z and pass back vector. You should generally not call this method directly, you should use FunctionGradient() instead. This method must be implemented by any derived class. Implements vtkImplicitFunction.

virtual void vtkSuperquadric::SetCenter | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadric::SetCenter | ( | float | [3] | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual float* vtkSuperquadric::GetCenter | ( |  | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadric::GetCenter | ( | float | data[3] | ) | `[virtual]`

| Set the center of the superquadric. Default is 0,0,0.

virtual void vtkSuperquadric::SetScale | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual void vtkSuperquadric::SetScale | ( | float | [3] | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual float* vtkSuperquadric::GetScale | ( |  | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual void vtkSuperquadric::GetScale | ( | float | data[3] | ) | `[virtual]`

| Set the scale factors of the superquadric. Default is 1,1,1.

virtual float vtkSuperquadric::GetThickness | ( |  | ) | `[virtual]`

| Set/Get Superquadric ring thickness (toroids only). Changing thickness maintains the outside diameter of the toroid.

virtual void vtkSuperquadric::SetThickness | ( | float |  | ) | `[virtual]`

| Set/Get Superquadric ring thickness (toroids only). Changing thickness maintains the outside diameter of the toroid.

virtual float vtkSuperquadric::GetPhiRoundness | ( |  | ) | `[virtual]`

| Set/Get Superquadric north/south roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

void vtkSuperquadric::SetPhiRoundness | ( | float | e | ) |

| Set/Get Superquadric north/south roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

virtual float vtkSuperquadric::GetThetaRoundness | ( |  | ) | `[virtual]`

| Set/Get Superquadric east/west roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

void vtkSuperquadric::SetThetaRoundness | ( | float | e | ) |

| Set/Get Superquadric east/west roundness. Values range from 0 (rectangular) to 1 (circular) to higher orders.

virtual void vtkSuperquadric::SetSize | ( | float |  | ) | `[virtual]`

| Set/Get Superquadric isotropic size.

virtual float vtkSuperquadric::GetSize | ( |  | ) | `[virtual]`

| Set/Get Superquadric isotropic size.

virtual void vtkSuperquadric::ToroidalOn | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual void vtkSuperquadric::ToroidalOff | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual int vtkSuperquadric::GetToroidal | ( |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

virtual void vtkSuperquadric::SetToroidal | ( | int |  | ) | `[virtual]`

| Set/Get whether or not the superquadric is toroidal (1) or ellipsoidal (0).

## Member Data Documentation

int vtkSuperquadric::Toroidal`[protected]`

| Definition at line 131 of file vtkSuperquadric.h.

float vtkSuperquadric::Thickness`[protected]`

| Definition at line 132 of file vtkSuperquadric.h.

float vtkSuperquadric::Size`[protected]`

| Definition at line 133 of file vtkSuperquadric.h.

float vtkSuperquadric::PhiRoundness`[protected]`

| Definition at line 134 of file vtkSuperquadric.h.

float vtkSuperquadric::ThetaRoundness`[protected]`

| Definition at line 135 of file vtkSuperquadric.h.

float vtkSuperquadric::Center[3]`[protected]`

| Definition at line 136 of file vtkSuperquadric.h.

float vtkSuperquadric::Scale[3]`[protected]`

| Definition at line 137 of file vtkSuperquadric.h.

The documentation for this class was generated from the following file:

- Filtering/vtkSuperquadric.h